from collections import namedtuple
import MySQLdb

Entity = namedtuple('Entity', 'id, name, country')

class Database:

    def __init__(self, host, user, pwd, database):
        self.host = host
        self.user = user
        self.pwd = pwd
        self.database = database
        self.db = MySQLdb.connect(self.host, self.user, self.pwd, self.database)
        self.db.autocommit(True)
        self.cursor = self.db.cursor()

    def __del__(self):
        self.db.close()

    def insert(self, item):
        try:
            self.cursor.execute(item)
            return self.cursor.lastrowid
        except:
            self.cursor.rollback()

    def select(self, item):
        try:
            self.cursor.execute(item)
            result = list()
            for i in self.cursor.fetchall():
                result.append(Entity(i[0], i[1], i[2]))
            return result
        except:
            self.cursor.rollback()


if __name__ == '__main__':
    select = 'SELECT id, name, country FROM wp_esi_entity WHERE id < 10'
    db = Database('localhost', 'root', 'andrew', 'esi')
    rows = db.select(select)
