# -*- coding: utf-8 -*-

# Define here the models for your spider middleware
#
# See documentation in:
# http://doc.scrapy.org/en/latest/topics/spider-middleware.html
import time
from scrapy import signals
from scrapy.http import HtmlResponse
from selenium import webdriver


class SeleniumDownloadMiddleware(object):
    # Not all methods need to be defined. If a method is not defined,
    # scrapy acts as if the spider middleware does not modify the
    # passed objects.

    @classmethod
    def from_crawler(cls, crawler):
        middleware = cls()
        crawler.signals.connect(middleware.spider_opened, signals.spider_opened)
        crawler.signals.connect(middleware.spider_closed, signals.spider_closed)
        return middleware

    def spider_opened(self, spider):
        spider.logger.info('Spider opened: %s' % spider.name)

        self.driver = webdriver.Chrome()
        self.driver.maximize_window()

    def spider_closed(self, spider):
        if self.driver:
            self.driver.quit()
        else:
            print('Driver closed by exception or error')

    def process_request(self, request, spider):
        self.driver.set_page_load_timeout(60)
        try:
            self.driver.get(request.url)

        except BaseException as e:
            print('Exception in process loading page')
            return None

        body = str.encode(self.driver.page_source)
        return HtmlResponse(self.driver.current_url, body=body, encoding='utf-8', request=request)