# -*- coding: utf-8 -*-
import dateparser
import scrapy

from ..helpers import CompanyMaker
from ..items import ExaItem


class MobiHealthNewsSpider(scrapy.Spider):
    name = "mobihealthnews"
    allowed_domains = ["www.mobihealthnews.com"]

    def start_requests(self):
        companies = CompanyMaker()
        companies.make_companies()
        for i in companies.get_companies():
            yield scrapy.Request(i.url, callback=self.parse, meta={'type_id': i.type_id,
                                                                   'region_id': i.region_id,
                                                                   'media_id': i.media_id})

    def parse(self, response):
        # try:
            rows = response.xpath("..//div[contains(@class, 'group-left')]//div[contains(@class, 'views-row')]")
            for i in rows:
                item = ExaItem()
                item['date'] = dateparser.parse(i.xpath(".//span/span[contains(@class, 'day_list')]/text()").extract_first()).date()
                item['media_id'] = response.meta['media_id']
                item['title'] = i.xpath(".//span/a/text()").extract_first()
                item['url'] = 'http://www.mobihealthnews.com' + i.xpath(".//span/a/@href").extract_first()
                item['region_id'] = response.meta['region_id']
                item['type_id'] = response.meta['type_id']

                yield item
            has_next = response.xpath("..//div[contains(@class, 'text-center')]/ul/li[contains(@class, 'next')]/a/text()").extract_first()
            next_url = 'http://www.mobihealthnews.com' + response.xpath("..//div[contains(@class, 'text-center')]/ul/li[contains(@class, 'next')]/a/@href").extract_first()
            print(has_next, next_url)

            if has_next:
                yield scrapy.Request(next_url, callback=self.parse, meta={'type_id': 1, 'region_id': 2, 'media_id': 43})

        # except BaseException:
        #     print('We had error')